
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue
#property indicator_width1 2
#property indicator_color2 White
#property indicator_width2 2
extern int place_background_in_window= 1, RSI_Period= 8, T3_Period= 8;
double T3Factor= 0.618, T3_line[], RSI_line[];
double e1,e2,e3,e4,e5,e6;
double c1,c2,c3,c4;
double n,w1,w2,b2,b3;

#define        MaxLevel "MaxLevel"
#define OverBoughtLevel "OverBoughtLevel"
#define      UpperLevel "UpperLevel"
#define      LowerLevel "LowerLevel"
#define   OverSoldLevel "OverSoldLevel"
#define        MinLevel "MinLevel"

int init() { string short_name; short_name= "X-T3 RSI"; IndicatorShortName(short_name);
IndicatorBuffers(2); IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
SetIndexBuffer(0,T3_line);   SetIndexStyle(0,DRAW_LINE);  SetIndexLabel(0,NULL);
SetIndexBuffer(1,RSI_line);  SetIndexStyle(1,DRAW_LINE);  SetIndexLabel(1,NULL);

e1= 0; e2= 0; e3= 0; e4= 0; e5= 0; e6= 0;
c1= 0; c2= 0; c3= 0; c4= 0;
n= 0;
w1= 0; w2= 0;
b2= 0; b3= 0;

b2= T3Factor* T3Factor; b3= b2* T3Factor;
c1= -b3; c2= (3* (b2+ b3)); c3= -3* (2* b2+ T3Factor+ b3); c4= (1+ 3* T3Factor+ b3+ 3* b2); n= T3_Period;
if (n<1) n=1; n= 1+ 0.5* (n- 1); w1= 2/ (n+ 1); w2= 1- w1; return(0); }

int start() { CreateLEVEL(); }

void CreateBox(string objName, double start, double start2, double end, double end2, color clr) {
   ObjectCreate(objName, OBJ_RECTANGLE, place_background_in_window, 0, start, Time[0], end, Time[0]);
      ObjectSet(objName, OBJPROP_COLOR, clr);
      ObjectSet(objName, OBJPROP_WIDTH, 1);
      ObjectSet(objName, OBJPROP_RAY, false);
      ObjectSet(objName, OBJPROP_BACK, 1); }
 
void DeleteCreateBox() { ObjectDelete(UpperLevel); ObjectDelete(LowerLevel); }
 
void CreateLEVEL() { DeleteCreateBox();
          CreateBox(MaxLevel,  80,  80,  100,  100, C'20,20,20');
   CreateBox(OverBoughtLevel,  70,  70,   80,   80, C'20,50,80');
        CreateBox(UpperLevel,  50,  50,   70,   70, C'40,60,80');  
        CreateBox(LowerLevel,  50,  50,   30,   30, C'30,40,50');
     CreateBox(OverSoldLevel,  30,  30,   20,   20, C'20,50,80');
          CreateBox(MinLevel,  20,  20, -100, -100, C'20,20,20');        

int limit= Bars; for(int i= limit; i>= 0; i--) {
RSI_line[i]= iRSI(NULL,0,T3_Period,PRICE_CLOSE,i);
e1= w1* RSI_line[i]+ w2*e1;
e2= w1* e1+ w2*e2;
e3= w1* e2+ w2*e3;
e4= w1* e3+ w2*e4;
e5= w1* e4+ w2*e5;
e6= w1* e5+ w2*e6;
T3_line[i]= c1* e6+ c2* e5+ c3* e4+ c4* e3; } return(0); }

